local initialized = false;
local MINIMAP_ICON = "Interface\\Icons\\inv_misc_key_15"
local dbDefaults = {
    profile = {
        profileversion = 3,
        minimap = {
            hide = false,
            minimapPos = 180,
        }
    }
}
local LibQTip = LibStub('LibQTip-1.0');
local addon = LibStub("AceAddon-3.0"):NewAddon("MyAlliedRaces", "AceConsole-3.0");
local icon = LibStub("LibDBIcon-1.0");

--Setup local variables
local Unknown = 0;
local Hated =  1;
local Hostile = 2;
local Unfriendly = 3;
local Neutral = 4;
local Friendly = 5;
local Honored = 6;
local Revered = 7;
local Exalted = 8;
local RepMax = {};
RepMax[0], RepMax[1], RepMax[2], RepMax[3], RepMax[4], RepMax[5], RepMax[6], RepMax[7], RepMax[8] = 0, 0, 0, 0, 3000, 6000, 12000, 21000, 42000;
--                                                                                                               Neu   Fri   Hon    Rev    Exa

-- Setup the Title Font. 14
local ssTitleFont = CreateFont("ssTitleFont")
ssTitleFont:SetTextColor(1,0.823529,0)

-- Setup the Header Font. 12
local ssHeaderFont = CreateFont("ssHeaderFont")
ssHeaderFont:SetTextColor(1,0.823529,0)

-- Setup the Regular Font. 12
local ssRegFont = CreateFont("ssRegFont")
ssRegFont:SetTextColor(1,0.823529,0)

local tooltip;
local LDB_ANCHOR;

local MyDO = LibStub("LibDataBroker-1.1"):NewDataObject("MyAlliedRaces", {
	type = "data source", 
	text = "Nothing to track!", 
	icon = MINIMAP_ICON,
	OnClick = function(self, button, ...)
		MyAlliedRaces_OnClick(self,button,...);
	end,
}); --added ;

function addon:ChangeView()
	if (MyAlliedRaces.Config.Darkiron and UnitFactionGroup("player") == "Alliance") then
		MyAlliedRaces.Config.Darkiron = false;
		MyAlliedRaces.Config.Lightforged = true;
	elseif (MyAlliedRaces.Config.Lightforged and UnitFactionGroup("player") == "Alliance") then
		MyAlliedRaces.Config.Lightforged = false;
		MyAlliedRaces.Config.Void = true;
	elseif (MyAlliedRaces.Config.Void and UnitFactionGroup("player") == "Alliance") then
		MyAlliedRaces.Config.Void = false;
		MyAlliedRaces.Config.KulTiran = true;
	elseif (MyAlliedRaces.Config.KulTiran and UnitFactionGroup("player") == "Alliance") then
		MyAlliedRaces.Config.KulTiran = false;
		MyAlliedRaces.Config.Mechagnome = true;
	elseif (MyAlliedRaces.Config.Mechagnome and UnitFactionGroup("player") == "Alliance") then
		MyAlliedRaces.Config.Mechagnome = false;
		MyAlliedRaces.Config.Darkiron = true;						
	elseif (MyAlliedRaces.Config.Nightborne and UnitFactionGroup("player") == "Horde") then
		MyAlliedRaces.Config.Nightborne = false;
		MyAlliedRaces.Config.Highmountain = true;
	elseif (MyAlliedRaces.Config.Highmountain and UnitFactionGroup("player") == "Horde") then
		MyAlliedRaces.Config.Highmountain = false;
		MyAlliedRaces.Config.Zandalari = true;
	elseif (MyAlliedRaces.Config.Zandalari and UnitFactionGroup("player") == "Horde") then
		MyAlliedRaces.Config.Zandalari = false;
		MyAlliedRaces.Config.Maghar = true;
	elseif (MyAlliedRaces.Config.Maghar and UnitFactionGroup("player") == "Horde") then
		MyAlliedRaces.Config.Maghar = false;
		MyAlliedRaces.Config.Vulpera = true;			
	elseif (MyAlliedRaces.Config.Vulpera and UnitFactionGroup("player") == "Horde") then
		MyAlliedRaces.Config.Vulpera = false;
		MyAlliedRaces.Config.Nightborne = true;			
	elseif (UnitFactionGroup("player") == "Alliance") then
		MyAlliedRaces.Config.Darkiron = true;
		MyAlliedRaces.Config.Lightforged = false;
		MyAlliedRaces.Config.Void = false;
		MyAlliedRaces.Config.KulTiran = false;
		MyAlliedRaces.Config.Mechagnome = false;
	elseif (UnitFactionGroup("player") == "Horde") then
		MyAlliedRaces.Config.Nightborne = true;
		MyAlliedRaces.Config.Highmountain = false;
		MyAlliedRaces.Config.Zandalari = false;
		MyAlliedRaces.Config.Maghar = false;
		MyAlliedRaces.Config.Vulpera = false;
	end
end

function addon:SlashHandler(msg)
	if msg == "help" then		
		print("|cffe5cc80MyAlliedRaces Help Menu|n|rUse |cff00ff00/ar|r or |cff00ff00/myar|r followed by a command, for example|n|cff00ff00toggle|r - toggles between BFA, Legion, and WoD|n|cff00ff00minimap|r - toggles the minimap icon on and off");		
	elseif msg == "toggle" or msg == "Toggle" then
		addon.ChangeView();
		MyAlliedRaces.Update();				
	elseif msg == "minimap"  or msg == "Minimap" then
		self.db.profile.minimap.hide = not self.db.profile.minimap.hide
		if self.db.profile.minimap.hide then
			print("|cffe5cc80MyAlliedRaces minimap icon is now disabled|r");
			icon:Hide("MyAlliedRaces")
		else						
			print("|cffe5cc80MyAlliedRaces minimap icon is now enabled|r");
			icon:Show("MyAlliedRaces")
		end
	else
		print("|n");
		print("|T" .. MyDO.icon .. ":0|t |cffe5cc80MyAlliedRaces - Allied Races Progression Tracker|n|rUse |cff00ff00/myatune help|r to view all available options");
		if MyAlliedRaces.Status and initialized then
			MyAlliedRaces.ProcessPrint(MyAlliedRaces.Status);
			print("|n" .. RED_FONT_COLOR_CODE .. "Achievements once completed on any character count for account wide progress. Blizzards earned by is not always accurate!");
		else 
			print("Error - Nothing to Output?");
		end
		print("|n");
	end
end

function addon:SelectionDefaults()
	--Void Elf, Lightforged Draenei, Dark Iron Dwarf, Kul Tiran Humans, Mechagnome (Alliance)
	--Nightborne, Highmountain Tauren, Zandalari Troll, Mag'har Orc, Vulpera (Horde)	
	if not MyAlliedRaces.Config then
		MyAlliedRaces.Config = {}
	end		
	if not MyAlliedRaces.Config.Transparent then
		MyAlliedRaces.Config.Transparent = true;
	end	
	if MyAlliedRaces.Config.Darkiron == nil then
		MyAlliedRaces.Config.Darkiron = true;
	end	
	if MyAlliedRaces.Config.Lightforged == nil then
		MyAlliedRaces.Config.Lightforged = false;
	end	
	if MyAlliedRaces.Config.Void == nil then
		MyAlliedRaces.Config.Void = false;
	end	
	if MyAlliedRaces.Config.KulTiran == nil then
		MyAlliedRaces.Config.KulTiran = false;
	end	
	if MyAlliedRaces.Config.Nightborne == nil then
		MyAlliedRaces.Config.Nightborne = true;
	end	
	if MyAlliedRaces.Config.Highmountain == nil then
		MyAlliedRaces.Config.Highmountain = false;
	end	
	if MyAlliedRaces.Config.Zandalari == nil then
		MyAlliedRaces.Config.Zandalari = false;
	end	
	if MyAlliedRaces.Config.Maghar == nil then
		MyAlliedRaces.Config.Maghar = false;
	end
	if MyAlliedRaces.Config.Vulpera == nil then
		MyAlliedRaces.Config.Vulpera = false;
	end		
	if MyAlliedRaces.Config.Mechagnome == nil then
		MyAlliedRaces.Config.Mechagnome = false;
	end		
end

function addon:OnInitialize()
	
	MyAlliedRaces.Status = Database;
	
	self.db = LibStub("AceDB-3.0"):New("MyAlliedRaces", dbDefaults, true)

	icon:Register("MyAlliedRaces", MyDO, self.db.profile.minimap)

	self:RegisterChatCommand("ar", "SlashHandler")
	self:RegisterChatCommand("myar", "SlashHandler")

	addon.SelectionDefaults();
					
	MyAlliedRaces.WordWrap = function (str)		
    local Lines = {};    
		local Words = { strsplit(" ", str) };    
		local count = 0;
    		local buildline = "";         
    		for k,v in pairs(Words) do    	
    			count = string.len(buildline) + string.len(v);    	    	   
    			if (count <= 50) then
    				buildline = buildline .. " " .. v;
    			else
    				table.insert(Lines, buildline);
    				buildline = v;
    				count = 0;
    			end    	    	
    		end    
    		table.insert(Lines, buildline);    
    		return Lines;    
	end
	
	MyAlliedRaces.GetColor = function (value)
		value = value * 2;
		local r = (2 - value);
		local g = value;
		local b = 0;
		
		if r > 1 then r = 1 end
		if g > 1 then g = 1 end
		if b > 1 then b = 1 end

		r = string.format("%i", r * 255);
		g = string.format("%i", g * 255);
		b = string.format("%i", b * 255);

		return "ff" .. string.format("%02x", r) .. string.format("%02x", g) .. string.format("%02x", b);
	end

	MyAlliedRaces.AchievementInfo = function (achievementID)
		local id, name, points, completed, month, day, year, description, flags, icon, rewardText, isGuild, wasEarnedByMe, earnedBy = GetAchievementInfo(achievementID);
		local quantity = 0;
		local reqquantity = 0;
		local numcriteria = GetAchievementNumCriteria(achievementID);
				
		if numcriteria > 0 then
			if ( numcriteria == 1 ) then
				reqquantity = select(5, GetAchievementCriteriaInfo(id, 1))
				quantity = select(4, GetAchievementCriteriaInfo(id, 1))
			else
				reqquantity = numcriteria;
				for index = 1, numcriteria do				
					local arg1, arg2, arg3, _ = select( 3, GetAchievementCriteriaInfo(id, index) );
					if ( arg1 == true ) then					
						quantity = quantity + 1;
					end		
				end				
			end									
		end
		return name, points, completed, icon, wasEarnedByMe, earnedBy, quantity, reqquantity, numcriteria, description, id;
	end

	MyAlliedRaces.FactionInfo = function (factionID)
		local name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID, hasBonusRepGain, canBeLFGBonus = GetFactionInfoByID(factionID);

		return name, description, standingID, barMin, barMax, barValue, hasRep, factionID;
	end
	

	MyAlliedRaces.Process = function (table, key)
		for k, v in pairs(table) do
			if type(v) == "table" then
				table[k] = MyAlliedRaces.Process(v, k);				
				if table[k].stype == "Faction" then
					table[k].name, table[k].description, table[k].standingID, table[k].barMin, table[k].barMax, table[k].barValue, table[k].hasRep, table[k].id =  MyAlliedRaces.FactionInfo(k);
				elseif table[k].stype == "Achievement"then
					table[k].name, table[k].points, table[k].completed, table[k].icon, table[k].wasEarnedByMe, table[k].earnedBy, table[k].quantity, table[k].reqquantity, table[k].numcriteria, table[k].description, table[k].id = MyAlliedRaces.AchievementInfo(k);
				end				
			end
		end
		return table;
	end
			
	MyAlliedRaces.GetPercent = function (n)	
		local s = 0;		
		if (n.stype == "Faction") then																	
			s = n.barValue / RepMax[8];		
			return "|c" .. MyAlliedRaces.GetColor(s) .. string.format("%#3.2f%%", s * 100) .. "|r";						
		elseif (n.stype == "Achievement") then			
			if n.completed then
				s = 1;
			elseif n.numcritieria == 0 then
				s = 0;
			else
				if (n.numcritieria == 1 and n.reqquantity > 1) then				
					s = 1 * ( n.quantity / n.reqquantity);
				else
					s = 1 * (n.quantity / n.reqquantity);
				end			
			end
			return "|c" .. MyAlliedRaces.GetColor(s) .. string.format("%#3.2f%%", s * 100) .. "|r";
		end
	end
	
	MyAlliedRaces.ProcessTooltip = function (data)		
		if (MyAlliedRaces.Config.Zandalari and UnitFactionGroup("player") == "Horde") then
			tooltip:AddLine("|n|cfff8b700Allied Race: |cffe53101Zandalari Troll|r|n|n");
			key = "zandalari";
		elseif (MyAlliedRaces.Config.Maghar and UnitFactionGroup("player") == "Horde") then
			tooltip:AddLine("|n|cfff8b700Allied Race: |cffe53101Mag'har Orc|r|n|n");	
			key = "maghar";	
		elseif (MyAlliedRaces.Config.Vulpera and UnitFactionGroup("player") == "Horde") then
			tooltip:AddLine("|n|cfff8b700Allied Race: |cffe53101Vulpera|r|n|n");
			key = "vulpera";
		elseif (MyAlliedRaces.Config.Nightborne and UnitFactionGroup("player") == "Horde") then
			tooltip:AddLine("|n|cfff8b700Allied Race: |cffe53101Nightborne|r|n|n");
			key = "nightborne";
		elseif (MyAlliedRaces.Config.Highmountain and UnitFactionGroup("player") == "Horde") then
			tooltip:AddLine("|n|cfff8b700Allied Race: |cffe53101Highmountain Tauren|r|n|n");
			key = "highmountain";
		elseif (MyAlliedRaces.Config.KulTiran and UnitFactionGroup("player") == "Alliance") then
			tooltip:AddLine("|n|cfff8b700Allied Race: |cffe53101Kul Tiran|r|n|n");
			key = "kultiran";
		elseif (MyAlliedRaces.Config.Darkiron and UnitFactionGroup("player") == "Alliance") then
			tooltip:AddLine("|n|cfff8b700Allied Race: |cffe53101Dark Iron Dwarf|r|n|n");
			key = "darkiron";		
		elseif (MyAlliedRaces.Config.Mechagnome and UnitFactionGroup("player") == "Alliance") then
			tooltip:AddLine("|n|cfff8b700Allied Race: |cffe53101Mechagnomes|r|n|n");
			key = "mechagnome";
		elseif (MyAlliedRaces.Config.Lightforged and UnitFactionGroup("player") == "Alliance") then
			tooltip:AddLine("|n|cfff8b700Allied Race: |cffe53101Lightforged Draenei|r|n|n");
			key = "lightforged";
		elseif (MyAlliedRaces.Config.Void and UnitFactionGroup("player") == "Alliance") then
			tooltip:AddLine("|n|cfff8b700Allied Race: |cffe53101Void Elf|r|n|n");	
			key = "void";																											
		end						
		for s1,s2 in pairs(data) do
			if(s1 == key) then
				so = data[key]["SortOrder"];
				for k1,v1 in ipairs(so) do
					for k2,v2 in pairs(s2) do						
						if(v1 == k2) then 
							MyAlliedRaces.Tooltip(v2);
						end				
					end
				end
			end
		end										
	end
	
	MyAlliedRaces.Tooltip = function (item)				
		if type(item) == "table" then															
			if item.name then
				
					local scolor = "|cffffffff"; --default
					if item.scolor then
						scolor = item.scolor;
					end
					
					local bformat = false; --default
					if item.bformat then
						bformat = item.bformat;
					end
					
					local sdisplay = "None"; --default
					if item.sdisplay then
						sdisplay = item.sdisplay;
					end
					
					local bcompleted = false; --default
					if item.completed == true then
						bcompleted = true;
					end
					
					local ntab = 1; --default
					local sspacing = ""; --default
					
					if item.ntab then
						ntab = item.ntab;
					end
					
					for i = 1, ntab, 1 do
						sspacing = sspacing .. "   ";
					end
					
					if bformat == true then
						tooltip:AddLine(" ");
					end
					
					if sdisplay == "None" then
						tooltip:AddLine(sspacing .. scolor .. item.name);
					elseif sdisplay == "Status" then
						if bcompleted == true then
							tooltip:AddLine(sspacing .. scolor .. item.name, GREEN_FONT_COLOR_CODE .. "Complete");	
						else
							tooltip:AddLine(sspacing .. scolor .. item.name, RED_FONT_COLOR_CODE .. "Incomplete");
						end
					else
						tooltip:AddLine(sspacing .. scolor .. item.name, MyAlliedRaces.GetPercent(item));
					end
					
					if item.bmoreinfo == true then			
						
						if item.scustom then
							
							local myTable = MyAlliedRaces.WordWrap(item.scustom);

							for k,v in pairs(myTable) do 
								if k == 1 then
									tooltip:AddLine(sspacing .. GRAY_FONT_COLOR_CODE .. "-" .. v); 
								else
									tooltip:AddLine(sspacing .. GRAY_FONT_COLOR_CODE .. "  " .. v); 
								end
							end
						
						elseif item.description then
						
     					local myTable = MyAlliedRaces.WordWrap(item.description);

							for k,v in pairs(myTable) do 
								if k == 1 then
									tooltip:AddLine(sspacing .. GRAY_FONT_COLOR_CODE .. "-" .. v); 
								else
									tooltip:AddLine(sspacing .. GRAY_FONT_COLOR_CODE .. "  " .. v); 
								end
							end
							
						end

					end
					
			end
			
			for k, v in pairs(item) do				
					MyAlliedRaces.Tooltip(v);
			end
			
		end
	end
	
	MyAlliedRaces.ProcessPrint = function (data)
		if (MyAlliedRaces.Config.Zandalari and UnitFactionGroup("player") == "Horde") then
			print("|n|cfff8b700Allied Race: |cffe53101Zandalari Troll|r|n|n");
			key = "zandalari";
		elseif (MyAlliedRaces.Config.Maghar and UnitFactionGroup("player") == "Horde") then
			print("|n|cfff8b700Allied Race: |cffe53101Mag'har Orc|r|n|n");	
			key = "maghar";	
		elseif (MyAlliedRaces.Config.Vulpera and UnitFactionGroup("player") == "Horde") then
			print("|n|cfff8b700Allied Race: |cffe53101Vulpera|r|n|n");
			key = "vulpera";
		elseif (MyAlliedRaces.Config.Nightborne and UnitFactionGroup("player") == "Horde") then
			print("|n|cfff8b700Allied Race: |cffe53101Nightborne|r|n|n");
			key = "nightborne";
		elseif (MyAlliedRaces.Config.Highmountain and UnitFactionGroup("player") == "Horde") then
			print("|n|cfff8b700Allied Race: |cffe53101Highmountain Tauren|r|n|n");
			key = "highmountain";
		elseif (MyAlliedRaces.Config.KulTiran and UnitFactionGroup("player") == "Alliance") then
			print("|n|cfff8b700Allied Race: |cffe53101Kul Tiran|r|n|n");
			key = "kultiran";
		elseif (MyAlliedRaces.Config.Darkiron and UnitFactionGroup("player") == "Alliance") then
			print("|n|cfff8b700Allied Race: |cffe53101Dark Iron Dwarf|r|n|n");
			key = "darkiron";		
		elseif (MyAlliedRaces.Config.Mechagnome and UnitFactionGroup("player") == "Alliance") then
			print("|n|cfff8b700Allied Race: |cffe53101Mechagnomes|r|n|n");
			key = "mechagnome";
		elseif (MyAlliedRaces.Config.Lightforged and UnitFactionGroup("player") == "Alliance") then
			print("|n|cfff8b700Allied Race: |cffe53101Lightforged Draenei|r|n|n");
			key = "lightforged";
		elseif (MyAlliedRaces.Config.Void and UnitFactionGroup("player") == "Alliance") then
			print("|n|cfff8b700Allied Race: |cffe53101Void Elf|r|n|n");	
			key = "void";																											
		end						
		for s1,s2 in pairs(data) do
			if(s1 == key) then
				so = data[key]["SortOrder"];
				for k1,v1 in ipairs(so) do
					for k2,v2 in pairs(s2) do						
						if(v1 == k2) then 
							MyAlliedRaces.Print(v2);
						end				
					end
				end
			end
		end	
	end
					
	MyAlliedRaces.Print = function (item)
		
		if type(item) == "table" then
			
			if item.name then
				
					local scolor = "|cffffffff"; --default
					if item.scolor then
						scolor = item.scolor;
					end
					
					local bformat = false; --default
					if item.bformat then
						bformat = item.bformat;
					end
					
					local sdisplay = "None"; --default
					if item.sdisplay then
						sdisplay = item.sdisplay;
					end
					
					local bcompleted = false; --default
					if item.completed == true then
						bcompleted = true;
					end
					
					local ntab = 1; --default
					local sspacing = ""; --default
					
					if item.ntab then
						ntab = item.ntab;
					end
					
					for i = 1, ntab, 1 do
						sspacing = sspacing .. "   ";
					end
					
					if bformat == true then
						print(" ");
					end
					
					if sdisplay == "None" then
						print(sspacing .. scolor .. item.name);
					elseif sdisplay == "Status" then
						if bcompleted == true then
							print(sspacing .. scolor .. item.name, GREEN_FONT_COLOR_CODE .. "Complete");	
						else
							print(sspacing .. scolor .. item.name, RED_FONT_COLOR_CODE .. "Incomplete");
						end
					else
						print(sspacing .. scolor .. item.name, MyAlliedRaces.GetPercent(item));
					end
					
					if item.bmoreinfo == true then			
						
						if item.scustom then
							
							local myTable = MyAlliedRaces.WordWrap(item.scustom);

							for k,v in pairs(myTable) do 
								if k == 1 then
									print(sspacing .. GRAY_FONT_COLOR_CODE .. "-" .. v); 
								else
									print(sspacing .. GRAY_FONT_COLOR_CODE .. "  " .. v); 
								end
							end
						
						elseif item.description then
						
     					local myTable = MyAlliedRaces.WordWrap(item.description);

							for k,v in pairs(myTable) do 
								if k == 1 then
									print(sspacing .. GRAY_FONT_COLOR_CODE .. "-" .. v); 
								else
									print(sspacing .. GRAY_FONT_COLOR_CODE .. "  " .. v); 
								end
							end
							
						end

					end
					
			end
			for k, v in pairs(item) do				
					MyAlliedRaces.Print(v);
			end
		end
	end

	MyAlliedRaces.Update = function ()
		local output = "";
		MyAlliedRaces.Status = MyAlliedRaces.Process(MyAlliedRaces.Status);
		
		if (MyAlliedRaces.Config.Darkiron and UnitFactionGroup("player") == "Alliance") then
			if MyAlliedRaces.Status["darkiron"][13089].completed == true then
				output = output .. " |cFFE77324Dark Iron Dwarf|r: " .. GREEN_FONT_COLOR_CODE .. "Unlocked";
			else
				output = output .. " |cFFE77324Dark Iron Dwarf|r: " .. RED_FONT_COLOR_CODE .. "Locked";
			end
		elseif (MyAlliedRaces.Config.Lightforged and UnitFactionGroup("player") == "Alliance") then
			if MyAlliedRaces.Status["lightforged"][12448].completed == true then
				output = output .. " |cFFE77324Lightforged Draenei|r: " .. GREEN_FONT_COLOR_CODE .. "Unlocked";
			else
				output = output .. " |cFFE77324Lightforged Draenei|r: " .. RED_FONT_COLOR_CODE .. "Locked";
			end		
		elseif (MyAlliedRaces.Config.Void and UnitFactionGroup("player") == "Alliance") then
			if MyAlliedRaces.Status["void"][12447].completed == true then
				output = output .. " |cFFE77324Void Elf|r: " .. GREEN_FONT_COLOR_CODE .. "Unlocked";
			else
				output = output .. " |cFFE77324Void Elf|r: " .. RED_FONT_COLOR_CODE .. "Locked";
			end	
		elseif (MyAlliedRaces.Config.KulTiran and UnitFactionGroup("player") == "Alliance") then
			
			if MyAlliedRaces.Status["kultiran"][13160].completed == true then
				output = output .. " |cFFE77324Kul Tiran Human|r: " .. GREEN_FONT_COLOR_CODE .. "Unlocked";
			else
				output = output .. " |cFFE77324Kul Tiran Human|r: " .. RED_FONT_COLOR_CODE .. "Locked";
			end				
		elseif (MyAlliedRaces.Config.Mechagnome and UnitFactionGroup("player") == "Alliance") then			
			if MyAlliedRaces.Status["mechagnome"][13991].completed == true then
				output = output .. " |cFFE77324Mechagnomes|r: " .. GREEN_FONT_COLOR_CODE .. "Unlocked";
			else
				output = output .. " |cFFE77324Mechagnomes|r: " .. RED_FONT_COLOR_CODE .. "Locked";
			end			
		elseif (MyAlliedRaces.Config.Nightborne and UnitFactionGroup("player") == "Horde") then
			if MyAlliedRaces.Status["nightborne"][12446].completed == true then
				output = output .. " |cFFE77324Nightborne|r: " .. GREEN_FONT_COLOR_CODE .. "Unlocked";
			else
				output = output .. " |cFFE77324Nightborne|r: " .. RED_FONT_COLOR_CODE .. "Locked";
			end				
		elseif (MyAlliedRaces.Config.Highmountain and UnitFactionGroup("player") == "Horde") then
			if MyAlliedRaces.Status["highmountain"][12445].completed == true then
				output = output .. " |cFFE77324Highmountain Tauren|r: " .. GREEN_FONT_COLOR_CODE .. "Unlocked";
			else
				output = output .. " |cFFE77324Highmountain Tauren|r: " .. RED_FONT_COLOR_CODE .. "Locked";
			end						
		elseif (MyAlliedRaces.Config.Zandalari and UnitFactionGroup("player") == "Horde") then	
			
			if MyAlliedRaces.Status["zandalari"][13159].completed == true then
				output = output .. " |cFFE77324Zandalari Troll|r: " .. GREEN_FONT_COLOR_CODE .. "Unlocked";
			else
				output = output .. " |cFFE77324Zandalari Troll|r: " .. RED_FONT_COLOR_CODE .. "Locked";
			end				
		elseif (MyAlliedRaces.Config.Maghar and UnitFactionGroup("player") == "Horde") then
			if MyAlliedRaces.Status["maghar"][13092].completed == true then
				output = output .. " |cFFE77324Mag'har Orc|r: " .. GREEN_FONT_COLOR_CODE .. "Unlocked";
			else
				output = output .. " |cFFE77324Mag'har Orc|r: " .. RED_FONT_COLOR_CODE .. "Locked";
			end				
		elseif (MyAlliedRaces.Config.Vulpera and UnitFactionGroup("player") == "Horde") then
			if MyAlliedRaces.Status["vulpera"][13993].completed == true then
				output = output .. " |cFFE77324Vulpera|r: " .. GREEN_FONT_COLOR_CODE .. "Unlocked";
			else
				output = output .. " |cFFE77324Vulpera|r: " .. RED_FONT_COLOR_CODE .. "Locked";
			end									
		end				
		MyDO.text = output;		
	end
	
	initialized = true;
	return true;
end

function MyDO:Hide()
      if tooltip then
				tooltip:Clear();
        tooltip:Release()
        tooltip = nil
      end
end

function MyAlliedRaces_OnClick(self, button, ...)			
		if button == "LeftButton" then
			if IsControlKeyDown() then
				if (MyAlliedRaces.Config.Transparent == false) then
					MyAlliedRaces.Config.Transparent = true;
				else
					MyAlliedRaces.Config.Transparent = false;
				end
				tooltip:Release();
    		tooltip = nil;
    		MyDO:BuildToolTip(self);
			else
				ToggleAchievementFrame();
			end
		elseif button == "RightButton" then
			tooltip:Release();
    	tooltip = nil;			
			addon.ChangeView();		
			MyDO:BuildToolTip(self);
		end				
end

function GameTooltip_SetBackdropStyle(self, style)
	self:SetBackdrop(style);
	self:SetBackdropBorderColor((style.backdropBorderColor or TOOLTIP_DEFAULT_COLOR):GetRGB());
	self:SetBackdropColor((style.backdropColor or TOOLTIP_DEFAULT_BACKGROUND_COLOR):GetRGB());

	if self.TopOverlay then
		if style.overlayAtlasTop then
			self.TopOverlay:SetAtlas(style.overlayAtlasTop, true);
			self.TopOverlay:SetScale(style.overlayAtlasTopScale or 1.0);
			self.TopOverlay:Show();
		else
			self.TopOverlay:Hide();
		end
	end

	if self.BottomOverlay then
		if style.overlayAtlasBottom then
			self.BottomOverlay:SetAtlas(style.overlayAtlasBottom, true);
			self.BottomOverlay:SetScale(style.overlayAtlasBottomScale or 1.0);
			self.BottomOverlay:Show();
		else
			self.BottomOverlay:Hide();
		end
	end

end


function MyDO:OnEnter()		
	MyDO:BuildToolTip(self);		
end

TOOLTIP_STYLE_TRANS = {
	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border-Azerite",
	tile = false,
	tileEdge = false,
	tileSize = 16,
	edgeSize = 19,
	insets = { left = 4, right = 4, top = 4, bottom = 4 },
	backdropBorderColor = TOOLTIP_DEFAULT_COLOR,
	backdropColor = TOOLTIP_AZERITE_BACKGROUND_COLOR,
	overlayAtlasTop = "AzeriteTooltip-Topper";
	overlayAtlasTopScale = .75,
	overlayAtlasBottom = "AzeriteTooltip-Bottom";
};

TOOLTIP_STYLE_SOLID = {
	bgFile = "Interface\\Collections\\CollectionsBackgroundTile",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border-Azerite",
	tile = false,
	tileEdge = false,
	tileSize = 16,
	edgeSize = 19,
	insets = { left = 4, right = 4, top = 4, bottom = 4 },
	backdropBorderColor = TOOLTIP_DEFAULT_COLOR,
	backdropColor = TOOLTIP_AZERITE_BACKGROUND_COLOR,
	overlayAtlasTop = "AzeriteTooltip-Topper";
	overlayAtlasTopScale = .75,
	overlayAtlasBottom = "AzeriteTooltip-Bottom";
};


function MyDO:BuildToolTip(self)
	MyAlliedRaces.Update(); --Update data for tooltip		
	tooltip = LibQTip:Acquire("MyAlliedRaces", 2, "LEFT", "RIGHT");
	tooltip:Clear();			
	
	if (MyAlliedRaces.Config.Transparent == false) then
		GameTooltip_SetBackdropStyle(tooltip, TOOLTIP_STYLE_SOLID);
	else
		GameTooltip_SetBackdropStyle(tooltip, TOOLTIP_STYLE_TRANS);
	end

	ssHeaderFont:SetFont(GameTooltipHeaderText:GetFont());
	ssRegFont:SetFont(GameTooltipText:GetFont());
	ssTitleFont:SetFont(GameTooltipText:GetFont());		
	tooltip:SetHeaderFont(ssHeaderFont);
	tooltip:SetFont(ssRegFont);		
	tooltip:SmartAnchorTo(self);
	tooltip:SetAutoHideDelay(0.25, self)										
	tooltip:AddHeader("|cffe5cc80MyAlliedRaces - Allied Races Unlock Tracker|r|n");		
	MyAlliedRaces.ProcessTooltip(MyAlliedRaces.Status);						
	tooltip:AddLine("|n|cff00ff00Left Click|r to toggle Achievement tooltip");
	tooltip:AddLine("|cff00ff00Ctrl+Left Click|r to change tooltip background");
	tooltip:AddLine("|n|cff00ff00Right Click|r to toggle between races ");
	tooltip:AddLine("|n" .. RED_FONT_COLOR_CODE .. "Achievements once completed on any character count for account");
	tooltip:AddLine(RED_FONT_COLOR_CODE .. "wide progress. Blizzards earned by is not always accurate!");					
	tooltip:UpdateScrolling();
	tooltip:Show();			
end

local function EventHandler(self, event, ...)	
	if ( event == "VARIABLES_LOADED" and initialized == true ) then
		print("|cffe5cc80MyAlliedRaces v" .. GetAddOnMetadata("MyAlliedRaces", "Version") .. " Loaded!|r");	
	elseif ( event == "PLAYER_ENTERING_WORLD" and initialized == true ) then		
		MyAlliedRaces.Update();
	elseif (event == "UPDATE_FACTION" and initialized == true) then
		--print("UPDATE_FACTION");
		MyAlliedRaces.Update();
	elseif (event == "ACHIEVEMENT_EARNED" and initialized == true) then
		--print("ACHIEVEMENT_EARNED");
		MyAlliedRaces.Update();
	elseif (event == "CRITERIA_EARNED" and initialized == true) then
		--print("CRITERIA_EARNED");
		MyAlliedRaces.Update();
	end
end

local EventListener = CreateFrame("frame", "MyAlliedRaces");
EventListener:RegisterEvent("VARIABLES_LOADED");
EventListener:RegisterEvent("CRITERIA_EARNED");
EventListener:RegisterEvent("ACHIEVEMENT_EARNED");
EventListener:RegisterEvent("PLAYER_ENTERING_WORLD");
EventListener:RegisterEvent("UPDATE_FACTION");
EventListener:SetScript("OnEvent", EventHandler);
